#pragma once

#include <spa/utils/hook.h>

#include <pipewire/proxy.h>
#include <pipewire/extensions/profiler.h>

#include "PipewireNode.h"

namespace UkuiAudioFramwork
{
class Pipewire;

class PipewireProfiler
{

private:
    Pipewire *pipewire = nullptr;
    pw_proxy *profiler = nullptr;
    spa_hook profiler_listener;
    int check_profiler;

    struct point {
        struct PipewireNode* driver;
        struct PipewireNode::driver info;
    };

public:
    explicit PipewireProfiler(Pipewire *parent, uint32_t id, const spa_dict* props);
    virtual ~PipewireProfiler();

    int process_info(const struct spa_pod *pod, struct PipewireNode::driver *info);
    int process_clock(const struct spa_pod *pod, struct PipewireNode::driver *info);
    int process_driver_block(const struct spa_pod *pod, struct point *point);
    int process_follower_block(const struct spa_pod *pod, struct point *point);

    // private
    void _profiler_profile(const struct spa_pod *pod);
};
}
